#include <rpvmain.h>

double lambda_lle[3][3][3];
double lambda_lqd[3][3][3];

#define TO_INT(f) int(f-0.5)

extern "C" double softsusy_lle(double i1, double i2, double i3, double value)
{
  lambda_lle[TO_INT(i1)][TO_INT(i2)][TO_INT(i3)] = value;
  lambda_lle[TO_INT(i2)][TO_INT(i1)][TO_INT(i3)] = -value;
  return 0.;
}

extern "C" double softsusy_lqd(double i1, double i2, double i3, double value)
{
  lambda_lqd[TO_INT(i1)][TO_INT(i2)][TO_INT(i3)] = value;
  return 0.;
}

extern "C" double softsusy_msugra(double M0, double M12, double A0, double tb, double sgnMu, double Mt, double Mb, double GG)
{
  /*  fstream fs("input.slha", ios_base::out);
  fs << "Block MODSEL     # Select model\n"
     << "\t1    1     # sugra\n"
     << "\t4    1                   # RPV\n"
     << "Block SMINPUTS     # Standard Model inputs\n"
     << "\t3   " << GG << "     # alpha_s(MZ) SM MSbar\n"
     << "\t5   " << Mb << "     # mb(mb) SM MSbar\n"
     << "\t6   " << Mt << "     # mtop(pole)\n"
     << "Block MINPAR     # Input parameters\n"
     << "\t1   " << M0 << "     # m0\n"
     << "\t2   " << M12 << "     # m12\n"
     << "\t3   " << tb << "     # tanb\n"
     << "\t4   " << sgnMu << "     # sign(mu)\n"
     << "\t5   " << A0 << "     # A0\n";
  
  fs << "Block RVLAMLLEIN             # GUT scale RPV trilinear coupling\n"
     << "\t1 2 1  " << lambda_lle[0][1][0] << "\n"
     << "\t1 2 2  " << lambda_lle[0][1][1] << "\n"
     << "\t1 2 3  " << lambda_lle[0][1][2] << "\n"
     << "\t1 3 1  " << lambda_lle[0][2][0] << "\n"
     << "\t1 3 2  " << lambda_lle[0][2][1] << "\n"
     << "\t1 3 3  " << lambda_lle[0][2][2] << "\n"
     << "\t2 3 1  " << lambda_lle[1][2][0] << "\n"
     << "\t2 3 2  " << lambda_lle[1][2][1] << "\n"
     << "\t2 3 3  " << lambda_lle[1][2][2] << "\n";

  fs << "Block RVLAMLQDIN                  # GUT scale LQD couplings \n";
  for (int i = 0; i < 3; ++i)
    for (int j = 0; j < 3; ++j)
      for (int k = 0; k < 3; ++k)
	fs << "\t" << i+1 << " " << j+1 << " " << k+1 << "  " << lambda_lqd[i][j][k] << "\n";

  fs.close();
  system("$HOME/softsusy/bin/softpoint.x leshouches < input.slha > SLHA.txt");
  return 0;*/

  signal(SIGFPE, FPE_ExceptionHandler);
  double mGutGuess = 3.0e16;

  QedQcd oneset;

  double alphasMZ = GG, mtop = Mt, mbmb = Mb;
  oneset.setAlpha(ALPHAS, alphasMZ);
  oneset.setPoleMt(mtop);
  oneset.setMass(mBottom, mbmb);
  oneset.setMbMb(mbmb);
  oneset.toMz();

  RpvSoftsusy r;
  DoubleVector pars(3);
  pars(1) = M0; pars(2) = M12; pars(3) = A0;
  bool uni = true;

  r.setData(oneset);
  // Forced to do this, because SoftSUSY ends with an exception if the diagonal is fed
  r.setLam(1,2,1,lambda_lle[0][1][0]);
  r.setLam(1,2,2,lambda_lle[0][1][1]);
  r.setLam(1,2,3,lambda_lle[0][1][2]);
  r.setLam(1,3,1,lambda_lle[0][2][0]);
  r.setLam(1,3,2,lambda_lle[0][2][1]);
  r.setLam(1,3,3,lambda_lle[0][2][2]);
  r.setLam(2,3,1,lambda_lle[1][2][0]);
  r.setLam(2,3,2,lambda_lle[1][2][1]);
  r.setLam(2,3,3,lambda_lle[1][2][2]);
  for (int i = 0; i < 3; ++i)
    for (int j = 0; j < 3; ++j)
      for (int k = 0; k < 3; ++k)
	{
	  //	  r.setLam(i+1,j+1,k+1,lambda_lle[i][j][k]);
	  r.setLamPrime(i+1,j+1,k+1,lambda_lqd[i][j][k]);
	}
  r.rpvDisplay(pars);
  r.lowOrg(rpvSugraBcs, mGutGuess, pars, sgnMu, tb, oneset, uni);

  fstream stream("SLHA.txt", ios_base::out);
  r.slha1(stream, "sugra", pars, sgnMu, tb, 0., 1, mGutGuess, false);
  stream.close();
  return 0.;
}
